#!/usr/bin/env python

import warnings
warnings.filterwarnings("ignore")


import sys
import os
programpath = os.path.dirname(sys.argv[0])
os.chdir(os.path.join(".", programpath))
sys.path.append(programpath)

import time
import threading
import ConfigParser
import urllib2
import popen2
import re
import shlex
import pickle

import feedparser
# Shut the fuck up!!!
feedparser._debug = 0

DEBUG=0

class rssfetcher(threading.Thread):
    def __init__(self, parent, section):
        self.parent = parent
        self.section = section
        self.die = False
        self.debug = parent.debug
        self.dump = False
        self.processes = []
        self.oldrssfile = os.path.join(self.parent.path, "data", self.section + ".dat")
        self.oldrssmtime = 0
        threading.Thread.__init__(self)
        self.name = section
        return
    
    def run(self):
        self.name = self.section
        self.fetcher()
        return
        try:
            self.fetcher()
        except Exception, err:
            print "Aiyeee! Error in thread", self.getName()
            print "\t" , dir(err)
            print "Exiting."

            self.printprocesslist()
            
        return

    def printprocesslist(self):
        self.saverss()
        print "Waiting for:", self.name
        for p, cwd, command in self.processes:
            if p.poll() == -1:
                print 'PID: %s\nIn directory: %s\nCommand: %s' % (p.pid, cwd, command)
            else:
                self.processes.remove((p, cwd, command))
        while self.processes:
            for p, cwd, command in self.processes:
                if p.poll() != -1:
                    self.processes.remove((p, cwd, command))
            time.sleep(1)
        return
    
    def re_searcher(self, data):
        pat, haystack = data
        try:
            retval = re.search(pat, haystack)
        except:
            retval = None
        if self.debug: print "Re-searching in:", haystack
        return retval

    def saverss(self):
        # First save the old processlist We should keep only say 500 entries. HAHA HARDCODED!!!
        try:
            self.oldrss.entries = self.oldrss.entries[:500]
        except:
            pass
        pickle.dump(self.oldrss, open(self.oldrssfile,'w'))
        return
    
    def loadoldrss(self):
        # Import old RSS... 
        try:
            mtime = os.stat(self.oldrssfile)[8]
            if self.oldrssmtime < mtime:
                oldrss = pickle.load(open(self.oldrssfile))
                self.oldrssmtime = mtime
            else:
                oldrss = self.oldrss
        except:
            self.oldrss = oldrss = feedparser.parse("")
            self.saverss()
        self.oldrss = oldrss
        return oldrss
    
    def fetcher(self):
        if self.debug: print "Entering Fetcher"
        rss = None
        self.loadoldrss()
        oldrss = self.oldrss
        
        while self.die == False:
            c = self.parent.config
            section = self.section
            if c.has_option(section, 'filter'):
                filters = c.get(section, "filter").strip()
                if self.debug: print "Filters:", filters
                filters = [ re.compile(regex) for regex in shlex.split(filters) ]
            else:
                filters = []

            if c.has_option(section, 'action'):
                actions = c.get(section, "action").strip()
                actions = shlex.split(actions)
            else:
                actions = []
                
            if c.has_option(section, "lookfor"): lookfor = c.get(section, "lookfor")
            else:  lookfor = ""
            if self.debug: print "Lookfor:", lookfor
                
            if c.has_option(section, "retrytime"): wait = int(c.get(section, "retrytime"))
            else:  wait = 1

            if c.has_option(section, 'feed'): feed = c.get(section, "feed")
            else: feed = None
            if c.has_option(section, 'pipe'): pipe = c.get(section, "pipe")
            else: pipe = None

            if pipe and not feed:
                p = popen2.Popen3(pipe)
                feed = p.fromchild.read()
            else:
                feed = urllib2.urlopen(feed).read()
        
            rss = feedparser.parse(feed)

            if self.dump:
                for key, val in rss.entries[0].items():
                    print key, val
                return
            
            if self.debug:
                print "Feed title: " , rss.feed.title

            # Alright, see if anything new matches
            for new in rss.entries: 
                if new in oldrss.entries: continue
                print "New Item incoming."
                if self.debug: print "Processing item:", new
                oldrss.entries.insert(0,new)
                doActions = actions[:]
                hitActions = []
                anyhit = 0
                for pattern in filters:
                    hit = 0
                    if lookfor:
                        if re.search(pattern, new[lookfor]): hit = 1; anyhit = 1
                    else:
                        if filter(self.re_searcher, [ (pattern, x) for x in  new.values() ] ): hit = 1; anyhit = 1
                    if self.debug: print "Hit:", hit, len(actions), len(filters)
                    if (len(actions) == len(filters)) and hit:
                        index = filters.index(pattern)
                        hitActions.append(index)
                        if self.debug: print "Hits, and adding action:", index
                        if self.debug: print "New elements keys:", new.keys()
                        for key in new.keys():
                            try:
                                rpl =  str(new[key])
                            except:
                                rpl = new[key]
                            if self.debug: print "Processing key:", key
                            doActions[index] = doActions[index].replace("%%%s" % key, rpl)
                                
                if self.debug: print "AnyHit:", anyhit
                if (len(filters) > len(actions)) and anyhit:
                    if self.debug: print "Replacing all actions!"
                    for index in range(len(actions)):
                        hitActions.append(index)
                        for key in new.keys():
                            try:
                                rpl =  str(new[key])
                            except:
                                rpl = new[key]
                            doActions[index] = doActions[index].replace("%%%s" % key, rpl)

                if hitActions:
                    for index in hitActions:
                        print "Running command:\n\t", doActions[index]
                        s = popen2.Popen3(doActions[index])
                        self.processes.append((s, self.parent.path, doActions[index] ))

            print "Sleeping...", wait
            for t in range(wait):
                if not self.die:
                    time.sleep(1)
        if self.debug:
            print "Thread for rss", section,"dying.. bye"
        self.printprocesslist()
        return


class control:
    def __init__(self, path, debug = False):
        self.debug = debug
        self.fetchers = fetchers = []
        self.configfile = os.path.join(path, "rssdaemon.cfg")
        self.cfgmtime = os.stat(self.configfile)[8]
        self.path = path
        config = self.loadconfig()
        
        for section in config.sections():
            print section
            f = rssfetcher(self, section)
            f.setName(section)
            f.setDaemon(True)
            if "--dump-only" in sys.argv:
                f.dump = True
            f.start()
            self.fetchers.append(f)

        while True:
            try:
                while True:
                    mtime = os.stat(self.configfile)[8]
                    if mtime > self.cfgmtime:
                        self.cfgmtime = mtime
                        self.loadconfig()
                    if not self.fetchers:
                        return
                    for fetcher in self.fetchers:
                        if not fetcher.isAlive():
                            self.fetchers.remove(fetcher)
                        else:
                            # Check old rss file
                            if not os.path.exists(fetcher.oldrssfile): fetcher.loadoldrss()
                            
                    time.sleep(1)
            except KeyboardInterrupt:
                    print "Taking down all fetchers.."
                    for fetcher in self.fetchers:
                        if self.debug: print "Killing", fetcher.name
                        fetcher.die = True
            
        return

    def loadconfig(self):
        self.config = config = ConfigParser.ConfigParser()
        config.read(self.configfile)
        return config

c = control(programpath, DEBUG)
            
